// CalendarJapan.cpp: implementation of the CCalendarJapan class.
//
//////////////////////////////////////////////////////////////////////

#include "CalendarJapan.h"
#include <cstring>
#include <cstdio>

string CCalendarJapan::m_strNames[] = {
    "Rat",
    "Bull",
    "Tiger",
    "Hare",
    "Dragon",
    "Snake",
    "Horse",
    "Sheep",
    "Monkey",
    "Bird",
    "Dog",
    "Boar"
};

int CCalendarJapan::m_nLengths[] = {
	29, 30, 29, 30, 29, 30, 29, 30, 29, 30, 29, 30
};

CCalendarJapan* CCalendarJapan::m_pInstance = NULL;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCalendarJapan::CCalendarJapan()
{
}

CCalendarJapan::~CCalendarJapan()
{
}

int CCalendarJapan::getFirstMonth()
{
	return RAT;
}

int CCalendarJapan::getLastMonth()
{
	return BOAR;
}

int CCalendarJapan::getMonthLength(int nMonth)
{
	return m_nLengths[nMonth];
}

string CCalendarJapan::getMonthName(int nMonth)
{
	return m_strNames[nMonth];
}

string CCalendarJapan::getHoliday(int nDay, int nMonth)
{
	string strRtn;
	bool bFull = false;

     if (nDay == 15)
	 {
         strRtn = "Full Moon";
		 bFull = true;
	 }
     if (nDay == m_nLengths[nMonth])
	 {
         strRtn = "New Moon";
		 bFull = true;
	 }
     switch (nDay) { 
     case 1:
     case 15 : 
		 if (bFull) strRtn += ", ";
		 strRtn += "Shinto";
		 bFull = true;
         break;
     case 8:
     case 18 : 
		 if (bFull) strRtn += ", ";
		 strRtn += "Buddhist";
		 bFull = true;
         break;
     case 28 : 
		 if (bFull) strRtn += ", ";
		 strRtn += "Buddhist, Shinto";
		 bFull = true;
         break;
     }
     switch (nMonth) {
     case RAT : 
         if ((nDay >= 1) && (nDay <= 6))
		 {
			 if (bFull) strRtn += ", ";
             strRtn += "New Years (s)";
		 }
         break;
     case BULL :
         switch (nDay) { 
         case 1: case 2: case 4: case 5: case 6: case 7:
			 if (bFull) strRtn += ", ";
             strRtn += "Equinox (b)";
             break;
         case 3: 
			 if (bFull) strRtn += ", ";
             strRtn += "Setsuban (1st Day of Spring) (s)";
             break;
         }
         break;
     case TIGER :
         if (nDay == 3)
		 {
			 if (bFull) strRtn += ", ";
             strRtn += "Doll Festival (c)";
		 }
         break;
     case HARE :
         if (nDay == 8)
		 {
			 if (bFull) strRtn += ", ";
             strRtn += "Buddha's Birthday (b)";
		 }
         break;
     case DRAGON :
         if (nDay == 5) 
		 {
			 if (bFull) strRtn += ", ";
             strRtn += "Boy's Day (c)";
		 }
         break;
     case SNAKE :
         switch (nDay) {
         case 1: case 2: case 3: case 4: case 5: case 6: case 7: 
			 if (bFull) strRtn += ", ";
             strRtn += "Rice Planting Festival (p)";
             break;
         case 30 : 
			 if (bFull) strRtn += ", ";
             strRtn += "All debts paid (p)";
         }
         break;
     case HORSE :
         switch (nDay) {
         case 1 : 
			 if (bFull) strRtn += ", ";
             strRtn += "Midyear (p)";
             break;
         case 7 : 
			 if (bFull) strRtn += ", ";
             strRtn += "Tanabata (Star Festival) (c)";
             break;
         case 13: case 14: case 15: 
			 if (bFull) strRtn += ", ";
             strRtn += "Bon Festival (for the dead) (b)";
         }
         break;
     case SHEEP :
         if ((nDay >= 1) && (nDay <= 7)) 
		 {
			 if (bFull) strRtn += ", ";
             strRtn += "Equinox (b)";
		 }
         break;
     case BIRD :
         switch (nDay) { 
         case 15 : 
			 if (bFull) strRtn += ", ";
             strRtn += "Rice Harvest Festival (p)";
             break;
         case 20 : 
			 if (bFull) strRtn += ", ";
             strRtn += "Festival of Ebishu (s)";
         } 
         break;
     case DOG :
         if (nDay == 8) 
		 {
			 if (bFull) strRtn += ", ";
             strRtn += "Feast of the Bellows (s)";
		 }
         break;
     case BOAR :
         if (nDay == 30) 
		 {
			 if (bFull) strRtn += ", ";
             strRtn += "All debts paid (p)";
		 }
     }
	 return strRtn;
}

CCalendarJapan* CCalendarJapan::instance()
{
	if (!m_pInstance)
	{
		m_pInstance = new CCalendarJapan();
	}
	return m_pInstance;
}
