// ClimateSAtlantic.cpp: implementation of the CClimateSAtlantic class.
//
//////////////////////////////////////////////////////////////////////

#include <cstddef>

#include "ClimateSAtlantic.h"

int CClimateSAtlantic::m_nAveTemp[] = {50, 60, 65, 70, 75, 80, 85, 80, 75, 65, 55, 50};

int CClimateSAtlantic::m_nWeatherTable[12][4] = {
    {30,35,0,100}, {25,35,0,100}, {20,30,0,100}, {35,50,0,100}, {25,40, 42,100}, {15,25, 27,100}, 
    {10,15,17,100}, {10,15,17,100}, {15,25,27,100}, {25,35,36,100}, {25,40,0,100}, {30,45,0,100}
};

int CClimateSAtlantic::m_nWindTable[12][5] = {
    {60,80,90,100,0}, {50,70,85,100,0}, {40,60,75,99,100}, {60,85,95,100,0}, {70,90,100,0,0}, {80,90,100,0,0}, 
    {80,100,0,0,0}, {80,100,0,0,0}, {60,80,95,100,0}, {40,65,85,97,100}, {40,60,80,95,100}, {60,80,90,100,0}
};

int CClimateSAtlantic::m_nPrecipTable[12][5] = {
    {0,40,70,80,100},
    {0,50,80,95,100},
    {0,60,80,100,0},
    {0,40,70,90,100},
    {0,50,80,100,0},
    {0,60,90,100,0},
    {0,80,95,100,0},
    {0,80,95,100,0},
    {0,60,80,90,100},
    {0,50,80,90,100},
    {0,40,70,85,100},
    {0,40,70,80,100}
};

int CClimateSAtlantic::m_nOvercastTable[] = {10,20,70,100};

CClimateSAtlantic* CClimateSAtlantic::m_pInstance = NULL;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CClimateSAtlantic::CClimateSAtlantic()
{
}

CClimateSAtlantic::~CClimateSAtlantic()
{

}

int CClimateSAtlantic::getAveTemp(int nMonth)
{
	return m_nAveTemp[nMonth];
}

int CClimateSAtlantic::getWeather(int nMonth, int nTyp)
{
	return m_nWeatherTable[nMonth][nTyp];
}


int CClimateSAtlantic::getWind(int nMonth, int nTyp)
{
	return m_nWindTable[nMonth][nTyp];
}


int CClimateSAtlantic::getPrecip(int nMonth, int nTyp)
{
	return m_nPrecipTable[nMonth][nTyp];
}


int CClimateSAtlantic::getOvercast(int nTyp)
{
	return m_nOvercastTable[nTyp];
}

CClimateSAtlantic* CClimateSAtlantic::instance()
{
	if (!m_pInstance)
	{
		m_pInstance = new CClimateSAtlantic();
	}
	return m_pInstance;
}
