// Overcast.cpp: implementation of the COvercast class.
//
//////////////////////////////////////////////////////////////////////

#include "Overcast.h"
#include "WeatherReport.h"
#include "Weather.h"
#include "Climate.h"
#include "Dice.h"

string COvercast::m_strNames[] = {
    "Heavy Fog",
    "Light Fog",
    "Mist",
    "Cloudy",
	"Clear",
};

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

COvercast::COvercast(int nOvercast)
{
	m_nType = nOvercast;
}

COvercast::~COvercast()
{

}

string COvercast::getName() const
{
	return m_strNames[m_nType];
}

/* generate today's level of cloudiness */

void COvercast::randomType()
{
     int roll;
	 CWeatherReport* pReport = CWeatherReport::instance();
	 int nWeather = pReport->getWeather();

     m_nType = CLEAR;
     if (nWeather == CWeather::CLEAR)
	 {
		 m_nType = CLEAR;
		 return;
	 }
     if (nWeather == CWeather::TAIFUN)
	 {
		 m_nType = CLOUDY;
		 return;
	 }

     if ((nWeather == CWeather::PRECIPITATION) || (nWeather == CWeather::OVERCAST))
	 {
		 roll = CDice::roll(100);
         m_nType = CLOUDY;
		 CClimate* pClimate = pReport->getClimate();

         for (int i = CLOUDY; i >= HEAVY_FOG; i--)
		 {
             if (roll <= pClimate->getOvercast(i))
			 {
                 m_nType = i;
			 }
		 }
	 }
}

